package org.rsg.interfascia_v2;

import processing.core.*;

public class PGraphicsState {
	public int rectMode, ellipseMode, textAlign, textMode, tintColor, fillColor, strokeColor, cMode;
	public PFont textFont;
	public boolean smooth, tint, fill, stroke;
	public float strokeWeight, textSize, cModeX, cModeY, cModeZ, cModeA;
	
	public PGraphicsState() {}

	public PGraphicsState(PApplet papplet) {
		saveSettingsForApplet(papplet);
	}

	public void saveSettingsForApplet(PApplet papplet) {
		smooth 			= papplet.g.smooth;
		rectMode 		= papplet.g.rectMode;
		ellipseMode 	= papplet.g.ellipseMode;
		textFont 		= papplet.g.textFont;
		textAlign 		= papplet.g.textAlign;
		textSize 		= papplet.g.textSize;
		textMode 		= papplet.g.textMode;
		tint 			= papplet.g.tint;
		fill 			= papplet.g.fill;
		stroke 			= papplet.g.stroke;
		tintColor 		= papplet.g.tintColor;
		fillColor 		= papplet.g.fillColor;
		strokeColor 	= papplet.g.strokeColor;
		strokeWeight 	= papplet.g.strokeWeight;
		cMode 			= papplet.g.colorMode;
		cModeX 			= papplet.g.colorModeX;
		cModeY 			= papplet.g.colorModeY;
		cModeZ 			= papplet.g.colorModeZ;
		cModeA 			= papplet.g.colorModeA;
	}

	public void restoreSettingsToApplet(PApplet papplet) {
		papplet.smooth();//this wasn't setting correctly, so overridded
		
		/*if (smooth)
			papplet.smooth();
		else
			papplet.noSmooth();*/
		
		papplet.rectMode(rectMode);
		papplet.ellipseMode(ellipseMode);
		
		if (textFont != null) {
			papplet.textFont(textFont);
			papplet.textSize(textSize);
		}
		
		papplet.textAlign(textAlign);
		papplet.textMode(textMode);
		
		if (tint)
			papplet.tint(tintColor);
		else
			papplet.noTint();
		
		if (fill)
			papplet.fill(fillColor);
		else
			papplet.noFill();
		
		if (stroke)
			papplet.stroke(strokeColor);
		else
			papplet.noStroke();
		
		papplet.strokeWeight(strokeWeight);
		papplet.colorMode(cMode, cModeX, cModeY, cModeZ, cModeA);
	}
}
