package org.rsg.interfascia_v2.components;

import org.rsg.interfascia_v2.Component;
import org.rsg.interfascia_v2.Constants;
import org.rsg.interfascia_v2.Font;

import processing.core.PApplet;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;

public class CheckBox extends Component {
	private static final String FONT = Font.SANS_SERIF;
	private static final int SIZE = Font.SMALL;
    private int currentColor;
    private boolean selected;
    public boolean isSelected() { return selected; }
    public void setSelected(boolean b) { selected = b; }

	public void setSize(PApplet papplet) { 
		this.font_size = SIZE; 
		Font.setFont(papplet, FONT, SIZE);
		int w = (int) papplet.textWidth(getLabel()) + Constants.RADIO_WIDTH + Constants.LEADING;
		int h = font_size;
		setSize(w, h);
	}
	
    public CheckBox(PApplet papplet, String newLabel, int newX, int newY) {
        selected = false;
        setLabel(newLabel);
        setPosition(newX, newY);
        setSize(papplet);
        setFontSize(SIZE);
        setFontFace(FONT);
    }

	public void initWithParent() {
		controller.papplet.registerMouseEvent(this);
	}
	
    /*public void initWithParent() {
        controller.papplet.registerMouseEvent(this);
		if (lookAndFeel == null) {
			return;
		} else {
			//controller.userState.saveSettingsForApplet(controller.papplet);
			//lookAndFeel.defaultGraphicsState.restoreSettingsToApplet(controller.papplet);
			setSize((int) Math.ceil(controller.papplet.textWidth(getLabel()))
					+ getHeight() + 5, 14);
			//controller.userState.restoreSettingsToApplet(controller.papplet);
			return;
		}
	}*/

    public void mouseEvent(MouseEvent e) {
		if (e.getID() == 501) {
			if (isMouseOver(e.getX(), e.getY()))
				wasClicked = true;
		} else if (e.getID() == 502 && wasClicked
				&& isMouseOver(e.getX(), e.getY())) {
			if (selected) {
				fireEventNotification(this, "Unchecked");
				selected = false;
			} else {
				fireEventNotification(this, "Checked");
				selected = true;
			}
			wasClicked = false;
		}
	}

    public void keyEvent(KeyEvent e) {
		if (e.getID() == 400 && e.getKeyChar() == ' ') {
			fireEventNotification(this, "Selected");
			if (selected) {
				fireEventNotification(this, "Unchecked");
				selected = false;
			} else {
				fireEventNotification(this, "Checked");
				selected = true;
			}
		}
	}

    public void draw() {
        if(isMouseOver(controller.papplet.mouseX, controller.papplet.mouseY))
            currentColor = lookAndFeel.highlightColor;
        else
        if(controller.getFocusStatusForComponent(this))
            currentColor = lookAndFeel.highlightColor;
        else
            currentColor = lookAndFeel.baseColor;
		int margin = 1;
		int x = getX() + margin;
		int y = getY() + margin;
		int hgt = getHeight() - margin*2;
		int wid = getWidth() - margin*2;
        
        //button
		controller.papplet.stroke(lookAndFeel.borderColor);
		controller.papplet.fill(currentColor);
		controller.papplet.rect(x, y, hgt, hgt);
        
        //button's check
        if(selected) {
			controller.papplet.stroke(lookAndFeel.borderColor);
			controller.papplet.line(x, y, x+hgt, y+hgt);
			controller.papplet.line(x+hgt, y, x, y+hgt);
        }
        
        //label
		controller.papplet.fill(lookAndFeel.textColor);
		Font.setFont(controller.papplet, font_face, font_size);
		controller.papplet.text(getLabel(), x + (hgt + 4), y + (hgt - 1));
        
        /*if(controller.showBounds)
        {
            controller.papplet.noFill();
            controller.papplet.stroke(255F, 0.0F, 0.0F);
            controller.papplet.rect(x, y, wid, hgt);
        }*/
    }
}
