package org.rsg.interfascia_v2.components;

import processing.core.PApplet;

//import org.rsg.interfascia.Link;
import org.rsg.interfascia_v2.Component;
import org.rsg.interfascia_v2.Font;

public class Label extends Component {	
	public boolean canReceiveFocus() { return false; }
	private static final String FONT = Font.SERIF;
	private static final int SIZE = Font.NORMAL;
	protected int currentColor;
	
	public void setSize(PApplet papplet, String face, int font_size) { 
		this.font_size = font_size; 
		Font.setFont(papplet, face, font_size);
		int w = (int) papplet.textWidth(getLabel());
		int h = font_size;
		setSize(w, h);
	}
	
	public Label(PApplet papplet, String s, int x, int y) {
		this(papplet, s, x, y, FONT, SIZE);
	}

	public Label(PApplet papplet, String s, int x, int y, int size) {
		this(papplet, s, x, y, FONT, size);
	}

	public Label(PApplet papplet, String s, int x, int y, String face, int size) {
        setFontSize(size);
        setFontFace(face);
		setLabel(s);
		setSize(papplet, face, size);
		setPosition(x, y);
	}
	
	private void setColor() {
		if (!isEnabled) {
			currentColor = lookAndFeel.lightGrayColor;
		
		} else if (this instanceof Link) {
			// MOUSDOWN ACTIVE
			boolean hasFocus = controller.getFocusStatusForComponent(this);
			if (wasClicked) {
				currentColor = lookAndFeel.activeColor;

			// MOUSEOVER HIGHLIGHTING
			} else if (isMouseOver(controller.papplet.mouseX,
					controller.papplet.mouseY)
					|| hasFocus) {
				currentColor = lookAndFeel.highlightColor;

			// NORMAL INACTIVE
			} else {
				currentColor = lookAndFeel.textColor;
			}

		} else {
			currentColor = lookAndFeel.textColor;			
		}
	

		controller.papplet.stroke(currentColor);
		controller.papplet.fill(currentColor);

	}

	public void draw() {
		setColor();
		Font.setFont(controller.papplet, font_face, font_size);
		controller.papplet.text(getLabel(), getX(), (getY() + font_size) - 3);
	}
}
