package org.rsg.interfascia_v2.components;

import java.awt.event.MouseEvent;
import org.rsg.interfascia_v2.components.Label;
import org.rsg.interfascia_v2.Font;
import org.rsg.lib.chrome.Chrome;

import processing.core.PApplet;

public class Link extends Label {
	private String url; 
	private static final String FONT = Font.SANS_SERIF;
	private static final int SIZE = Font.SMALL;

	public Link(PApplet papplet, String argLabel, int argX, int argY, String url) {
		super(papplet, argLabel, argX, argY, FONT, SIZE);
		this.url = url;
	}

	public void initWithParent() {
		controller.papplet.registerMouseEvent(this);
	}

	public void mouseEvent(MouseEvent e) {
		if (e.getID() == MouseEvent.MOUSE_PRESSED) { //501 == MOUSE_PRESSED
			if (isMouseOver(e.getX(), e.getY()))
				wasClicked = true;
		} else if (	e.getID() == MouseEvent.MOUSE_RELEASED && //502 == MOUSE_RELEASED
					wasClicked && 
					isMouseOver(e.getX(), e.getY())) {
			fireEventNotification(this, "Clicked");
			if(Chrome.FULL_SCREEN) {Chrome.toggleFullscreen(controller.papplet);} //always take app out of full screen before launching browser
			controller.papplet.link(url);
			wasClicked = false;
		}
	}

	public void draw() {
		super.draw();
		
		//add underline
		controller.papplet.noFill();
		controller.papplet.stroke(lookAndFeel.highlightColor);
		int x1 = getX() + 1;
		int y1 = getY() + font_size - 1;
		int x2 = x1 + this.getWidth() -2;
		int y2 = y1;
		controller.papplet.line(x1, y1, x2, y2);
	}
}
