package org.rsg.interfascia_v2.components;

import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;

import org.rsg.interfascia_v2.Component;
import org.rsg.interfascia_v2.Constants;
import org.rsg.interfascia_v2.Event;

public class TextField extends Component {
	private int currentColor;
	private String contents;
	private int cursorPos;
	private int visiblePortionStart;
	private int visiblePortionEnd;
	private int startSelect;
	private int endSelect;
	private float contentWidth;
	private float visiblePortionWidth;
	private float cursorXPos;
	private float startSelectXPos;
	private float endSelectXPos;

	public TextField(String newLabel, int newX, int newY) {
		this(newLabel, newX, newY, 200, "");
	}

	public TextField(String argLabel, int argX, int argY, int argWidth) {
		this(argLabel, argX, argY, argWidth, "");
	}

	public TextField(String argLabel, int argX, int argY, int argWidth, String newValue) {
		contents = "";
		cursorPos = 0;
		visiblePortionStart = 0;
		visiblePortionEnd = 0;
		startSelect = -1;
		endSelect = -1;
		contentWidth = 0.0F;
		visiblePortionWidth = 0.0F;
		cursorXPos = 0.0F;
		startSelectXPos = 0.0F;
		endSelectXPos = 0.0F;
		setLabel(argLabel);
		setPosition(argX, argY);
		setSize(argWidth, 21);
		setValue(newValue);
	}

	public static boolean validUnicode(char b) {
		int c = b;
		return c >= 32 && c <= 126 || c >= 161 && c <= 383 || c == 399
				|| c == 402 || c >= 416 && c <= 417 || c >= 431 && c <= 432
				|| c >= 464 && c <= 476 || c >= 506 && c <= 511 || c >= 536
				&& c <= 539 || c >= 592 && c <= 680 || c >= 688 && c <= 745
				|| c >= 768 && c <= 837 || c >= 884 && c <= 885 || c == 890
				|| c == 894 || c >= 900 && c <= 906 || c >= 910 && c <= 929
				|| c >= 931 && c <= 974 || c >= 976 && c <= 982 || c >= 986
				|| c >= 988 || c >= 990 || c >= 992 || c >= 994 && c <= 1011
				|| c >= 1025 && c <= 1103 || c >= 1105 && c <= 1116
				|| c >= 1118 && c <= 1158 || c >= 1168 && c <= 1220
				|| c >= 1223 && c <= 1225 || c >= 1227 && c <= 1228
				|| c >= 1232 && c <= 1259 || c >= 1262 && c <= 1269
				|| c >= 1272 && c <= 1273 || c >= 1425 && c <= 1441
				|| c >= 1443 && c <= 1476 || c >= 1488 && c <= 1514
				|| c >= 1520 && c <= 1524 || c >= 1548 || c >= 1563
				|| c >= 1567 || c >= 1569 && c <= 1594 || c >= 1600
				&& c <= 1621 || c >= 1632 && c <= 1774 || c >= 1776
				&& c <= 1790 || c >= 2305 && c <= 2361 || c >= 2364
				&& c <= 2381 || c >= 2384 && c <= 2388 || c >= 2392
				&& c <= 2416 || c >= 3585 && c <= 3642 || c >= 7808
				&& c <= 7813 || c >= 7840 && c <= 7929 || c >= 8192
				&& c <= 8238 || c >= 8240 && c <= 8262 || c == 8304
				|| c >= 8308 && c <= 8334 || c == 8337 || c >= 8352
				&& c <= 8364 || c >= 8448 && c <= 8504 || c >= 8531
				&& c <= 8578 || c >= 8592 && c <= 8682 || c >= 8592
				&& c <= 8682 || c >= 8192 && c <= 8945 || c == 8962
				|| c >= 8992 && c <= 8993 || c >= 9312 && c <= 9321
				|| c == 9472 || c == 9474 || c == 9484 || c == 9488
				|| c == 9492 || c == 9496 || c == 9500 || c == 9508
				|| c == 9516 || c == 9524 || c == 9532 || c >= 9552
				&& c <= 9580 || c == 9600 || c == 9604 || c == 9608
				|| c == 9612 || c >= 9616 && c <= 9619 || c == 9632
				|| c >= 9642 && c <= 9644 || c == 9650 || c == 9658
				|| c == 9660 || c == 9668 || c == 9670 || c >= 9674
				&& c <= 9676 || c == 9679 || c >= 9687 && c <= 9689
				|| c == 9702 || c == 9733 || c == 9742 || c == 9755
				|| c == 9758 || c >= 9786 && c <= 9788 || c == 9792
				|| c == 9794 || c == 9824 || c == 9827 || c == 9829
				|| c == 9830 || c == 9834 || c == 9835 || c >= 9985
				&& c <= 9993 || c >= 9996 && c <= 10023 || c >= 10025
				&& c <= 10059 || c == 10061 || c >= 10063 && c <= 10066
				|| c == 10070 || c >= 10072 && c <= 10078 || c >= 10081
				&& c <= 10087 || c >= 10102 && c <= 10132 || c >= 10136
				&& c <= 10174 || c >= 61441 && c <= 61442 || c >= 61473
				&& c <= 61695 || c >= 62977 && c <= 62981 || c >= 62992
				&& c <= 62998 || c >= 63488 && c <= 63495 || c >= 63498
				&& c <= 63499 || c >= 63502 && c <= 63505 || c >= 63508
				&& c <= 63509 || c >= 63519 && c <= 63520 || c >= 63519
				&& c <= 63520 || c == 63539;
	}

	public void initWithParent() {
		controller.papplet.registerMouseEvent(this);
	}

	private void addChar(char c) {
		String t1;
		String t2;
		if (startSelect != -1 && endSelect != -1) {
			if (startSelect > endSelect) {
				int temp = startSelect;
				startSelect = endSelect;
				endSelect = temp;
			}
			if (endSelect > contents.length())
				endSelect = contents.length();
			t1 = contents.substring(0, startSelect);
			t2 = contents.substring(endSelect);
			cursorPos = startSelect;
			startSelect = endSelect = -1;
		} else {
			t1 = contents.substring(0, cursorPos);
			t2 = contents.substring(cursorPos);
		}
		contents = t1 + c + t2;
		cursorPos++;
		if (controller.papplet.textWidth(contents) < (float) (getWidth() - 12)) {
			visiblePortionStart = 0;
			visiblePortionEnd = contents.length();
		} else if (cursorPos == contents.length()) {
			visiblePortionEnd = cursorPos;
			shrinkLeft();
		} else if (cursorPos >= visiblePortionEnd) {
			centerCursor();
		} else {
			visiblePortionEnd = visiblePortionStart;
			growRight();
		}
		fireEventNotification(this, "Modified");
	}

	private void backspaceChar() {
		String t1 = "";
		String t2 = "";
		if (startSelect != -1 && endSelect != -1) {
			if (startSelect > endSelect) {
				int temp = startSelect;
				startSelect = endSelect;
				endSelect = temp;
			}
			if (endSelect > contents.length())
				endSelect = contents.length();
			t1 = contents.substring(0, startSelect);
			t2 = contents.substring(endSelect);
			cursorPos = startSelect;
			startSelect = endSelect = -1;
			contents = t1 + t2;
		} else if (cursorPos > 0) {
			if (cursorPos > contents.length())
				cursorPos = contents.length();
			t1 = contents.substring(0, cursorPos - 1);
			t2 = contents.substring(cursorPos);
			cursorPos--;
			contents = t1 + t2;
		}
		if (controller.papplet.textWidth(contents) < (float) (getWidth() - 12)) {
			visiblePortionStart = 0;
			visiblePortionEnd = contents.length();
		} else if (cursorPos == contents.length()) {
			visiblePortionEnd = cursorPos;
			growLeft();
		} else if (cursorPos <= visiblePortionStart) {
			centerCursor();
		} else {
			visiblePortionEnd = visiblePortionStart;
			growRight();
		}
		fireEventNotification(this, "Modified");
	}

	private void deleteChar() {
		if (cursorPos >= contents.length()) {
			return;
		} else {
			cursorPos++;
			backspaceChar();
			return;
		}
	}

	private void updateXPos() {
		cursorXPos = controller.papplet.textWidth(contents.substring(
				visiblePortionStart, cursorPos));
		if (startSelect != -1 && endSelect != -1) {
			int tempStart;
			int tempEnd;
			if (endSelect < startSelect) {
				tempStart = endSelect;
				tempEnd = startSelect;
			} else {
				tempStart = startSelect;
				tempEnd = endSelect;
			}
			if (tempStart < visiblePortionStart)
				startSelectXPos = 0.0F;
			else
				startSelectXPos = controller.papplet.textWidth(contents
						.substring(visiblePortionStart, tempStart));
			if (tempEnd > visiblePortionEnd)
				endSelectXPos = getWidth() - 4;
			else
				endSelectXPos = controller.papplet.textWidth(contents
						.substring(visiblePortionStart, tempEnd));
		}
	}

	private void growRight() {
		for (; 	controller.papplet.textWidth(contents.substring(visiblePortionStart, visiblePortionEnd)) < 
				(float) (getWidth() - 12); 
				visiblePortionEnd++)
			if (visiblePortionEnd == contents.length()) {
				if (visiblePortionStart == 0)
					break;
				visiblePortionStart--;
			}
	}

	private void growLeft() {
		for (; controller.papplet.textWidth(contents.substring(
				visiblePortionStart, visiblePortionEnd)) < (float) (getWidth() - 12); visiblePortionStart--)
			if (visiblePortionStart == 0) {
				if (visiblePortionEnd == contents.length())
					break;
				visiblePortionEnd++;
			}

	}

	private void shrinkRight() {
		for (; controller.papplet.textWidth(contents.substring(
				visiblePortionStart, visiblePortionEnd)) > (float) (getWidth() - 12); visiblePortionEnd--)
			;
	}

	private void shrinkLeft() {
		for (; controller.papplet.textWidth(contents.substring(
				visiblePortionStart, visiblePortionEnd)) > (float) (getWidth() - 12); visiblePortionStart++)
			;
	}

	private void centerCursor() {
		for (visiblePortionStart = visiblePortionEnd = cursorPos; controller.papplet
				.textWidth(contents.substring(visiblePortionStart,
						visiblePortionEnd)) < (float) (getWidth() - 12);) {
			if (visiblePortionStart != 0)
				visiblePortionStart--;
			if (visiblePortionEnd != contents.length())
				visiblePortionEnd++;
			if (visiblePortionEnd == contents.length()
					&& visiblePortionStart == 0)
				break;
		}

	}

	private int findClosestGap(int x) {
		float prev = 0.0F;
		if (x < 0)
			return visiblePortionStart;
		if (x > getWidth())
			return visiblePortionEnd;
		for (int i = visiblePortionStart; i < visiblePortionEnd; i++) {
			float cur = controller.papplet.textWidth(contents.substring(
					visiblePortionStart, i));
			if (cur > (float) x)
				if (cur - (float) x < (float) x - prev)
					return i;
				else
					return i - 1;
			prev = cur;
		}

		return contents.length();
	}

	public void setValue(String newValue) {
		setValueWithEvent(newValue, true);
	}

	public void setValueNoEvent(String newValue) {
		setValueWithEvent(newValue, false);
	}

	public void setValueWithEvent(String newValue, boolean shouldFireEvent) {
		contents = newValue;
		cursorPos = contents.length();
		startSelect = endSelect = -1;
		visiblePortionStart = 0;
		visiblePortionEnd = contents.length();
		if (controller != null
				&& controller.papplet.textWidth(contents) > (float) (getWidth() - 12))
			shrinkRight();
		if (shouldFireEvent) {
			fireEventNotification(this, "Set");
		}
	}

	public String getValue() {
		return contents;
	}

	public void mouseEvent(MouseEvent e) {
		if(!isEnabled) {return;}

		//controller.userState.saveSettingsForApplet(controller.papplet);
		//lookAndFeel.defaultGraphicsState.restoreSettingsToApplet(controller.papplet);
		if (e.getID() == 501) {
			if (isMouseOver(e.getX(), e.getY())) {
				controller.requestFocus(this);
				wasClicked = true;
				endSelect = -1;
				startSelect = cursorPos = findClosestGap(e.getX() - getX());
			} else if (controller.getFocusStatusForComponent(this)) {
				wasClicked = false;
				controller.yieldFocus(this);
				startSelect = endSelect = -1;
			}
		} else if (e.getID() == 506)
			endSelect = cursorPos = findClosestGap(e.getX() - getX());
		else if (e.getID() == 502 && endSelect == startSelect) {
			startSelect = -1;
			endSelect = -1;
		}
		updateXPos();
		//controller.userState.restoreSettingsToApplet(controller.papplet);
	}

	public void keyEvent(KeyEvent e) {
		if(!isEnabled) {return;}
		
		//controller.userState.saveSettingsForApplet(controller.papplet);
		//lookAndFeel.defaultGraphicsState.restoreSettingsToApplet(controller.papplet);
		int shortcutMask = Toolkit.getDefaultToolkit().getMenuShortcutKeyMask();
		boolean shiftDown = (e.getModifiersEx() & 0x40) == 64;
		if (e.getID() == 401) {
			if (e.getKeyCode() == 40) {
				if (shiftDown) {
					if (startSelect == -1)
						startSelect = cursorPos;
					endSelect = cursorPos = visiblePortionEnd = contents
							.length();
				} else {
					startSelect = endSelect = -1;
					cursorPos = visiblePortionEnd = contents.length();
				}
				visiblePortionStart = visiblePortionEnd;
				growLeft();
			} else if (e.getKeyCode() == 38) {
				if (shiftDown) {
					if (endSelect == -1)
						endSelect = cursorPos;
					startSelect = cursorPos = visiblePortionStart = 0;
				} else {
					startSelect = endSelect = -1;
					cursorPos = visiblePortionStart = 0;
				}
				visiblePortionEnd = visiblePortionStart;
				growRight();
			} else if (e.getKeyCode() == 37) {
				if (shiftDown) {
					if (cursorPos > 0)
						if (startSelect != -1 && endSelect != -1) {
							startSelect--;
							cursorPos--;
						} else {
							endSelect = cursorPos;
							cursorPos--;
							startSelect = cursorPos;
						}
				} else if (startSelect != -1 && endSelect != -1) {
					cursorPos = Math.min(startSelect, endSelect);
					startSelect = endSelect = -1;
				} else if (cursorPos > 0)
					cursorPos--;
				centerCursor();
			} else if (e.getKeyCode() == 39) {
				if (shiftDown) {
					if (cursorPos < contents.length())
						if (startSelect != -1 && endSelect != -1) {
							endSelect++;
							cursorPos++;
						} else {
							startSelect = cursorPos;
							cursorPos++;
							endSelect = cursorPos;
						}
				} else if (startSelect != -1 && endSelect != -1) {
					cursorPos = Math.max(startSelect, endSelect);
					startSelect = endSelect = -1;
				} else if (cursorPos < contents.length())
					cursorPos++;
				centerCursor();
			} else if (e.getKeyCode() == 127)
				deleteChar();
			else if (e.getKeyCode() == 10)
				fireEventNotification(this, "Completed");
			else if ((e.getModifiers() & shortcutMask) == shortcutMask)
				switch (e.getKeyCode()) {
				case 67: // 'C'
					System.out.println("Copy");
					break;

				case 86: // 'V'
					System.out.println("Paste");
					break;

				case 88: // 'X'
					System.out.println("Cut");
					break;

				case 65: // 'A'
					startSelect = 0;
					endSelect = contents.length();
					break;
				}
		} else if (e.getID() == 400
				&& (e.getModifiers() & shortcutMask) != shortcutMask)
			if (e.getKeyChar() == '\b')
				backspaceChar();
			else if (e.getKeyChar() != '\uFFFF' && validUnicode(e.getKeyChar()))
				addChar(e.getKeyChar());
		updateXPos();
		//controller.userState.restoreSettingsToApplet(controller.papplet);
	}

	public void draw() {
		boolean hasFocus = controller.getFocusStatusForComponent(this);

		//BOX
		if (wasClicked)
			currentColor = lookAndFeel.activeColor;
		else if (isMouseOver(controller.papplet.mouseX,
				controller.papplet.mouseY)
				|| hasFocus)
			currentColor = lookAndFeel.highlightColor;
		else
			currentColor = lookAndFeel.baseColor;
		
		if(isEnabled) {
			controller.papplet.stroke(lookAndFeel.highlightColor);
		} else {
			controller.papplet.noStroke();			
		}
		controller.papplet.fill(Constants.GREY_LIGHTER.getRGB());
		controller.papplet.rect(getX(), getY(), getWidth(), getHeight());
		controller.papplet.noStroke();

		//TEXT
		float offset;
		if (cursorPos == contents.length()
				&& controller.papplet.textWidth(contents) > (float) (getWidth() - 8))
			offset = (float) (getWidth() - 4)
					- controller.papplet.textWidth(contents.substring(
							visiblePortionStart, visiblePortionEnd));
		else
			offset = 4F;
		if (hasFocus && startSelect != -1 && endSelect != -1) {
			controller.papplet.fill(lookAndFeel.selectionColor);
			controller.papplet.rect((float) getX() + startSelectXPos + offset,
					getY() + 3, (endSelectXPos - startSelectXPos) + 1.0F, 15F);
		}

		if(isEnabled) {
			controller.papplet.fill(lookAndFeel.textColor);
		} else {
			controller.papplet.fill(lookAndFeel.lightGrayColor);			
		}
		controller.papplet.text(contents.substring(visiblePortionStart,
				visiblePortionEnd), (float) getX() + offset, getY() + 4,
				getWidth() - 8, getHeight() - 6);

		//CURSOR
		if (hasFocus && (startSelect == -1 || endSelect == -1)
				&& controller.papplet.millis() % 1000 > 500) {
			controller.papplet.stroke(lookAndFeel.darkGrayColor);
			controller.papplet.line((float) (getX() + (int) cursorXPos)
					+ offset, getY() + 3, (float) (getX() + (int) cursorXPos)
					+ offset, getY() + 18);
		}
	}

	public void actionPerformed(Event e) {
		super.actionPerformed(e);
		if (e.getSource() == this)
			if (e.getMessage().equals("Received Focus")) {
				if (contents != "") {
					startSelect = 0;
					endSelect = contents.length();
				}
			} else if (e.getMessage().equals("Lost Focus") && contents != "")
				startSelect = endSelect = -1;
	}
}
