package org.rsg.interfascia_v2.components.list;

import org.rsg.interfascia_v2.Component;
import org.rsg.interfascia_v2.Constants;
import org.rsg.interfascia_v2.components.Stack4Components;

public class Radio extends Component {
	protected Stack4Components contents = new Stack4Components();
    private RadioEntry selected;
    
    public Radio() {}

    public Radio(String argLabel) {
        setLabel(argLabel);
    }

    public Radio(String argLabel, Object l) {
        setLabel(argLabel);
        addActionListener(l);
    }

    public void add(RadioEntry button) {
    	contents.add(button);
    }

    public void remove(RadioEntry button) {
    	contents.remove(button);
    }

    public RadioEntry getSelected() {
    	return selected;
    }

    public void selectButton(RadioEntry button) {
    	selected = button;
        fireEventNotification(button, "Selected");
    }

    public boolean getSelectionStatusForButton(RadioEntry button) {
    	return (selected == button) ? true : false;
    }

    public void deselectAll() {
        selected = null;
    }

    public void addActionListener(Object arglistener) {
        listener = arglistener;
    }
    
    public int size() {
    	return contents.size();
    }

    public void draw() {
        int x = getX();
        int y = getY();
        
    	//Log.debug(this.toString() + " x:"+x + " y:"+y);
        //if(visible) {
            //userState.saveSettingsForApplet(parent);
            //lookAndFeel.defaultGraphicsState.restoreSettingsToApplet(parent);
            for(int i = 0; i < size(); i++) {
                if(contents.get(i) != null) {
                    contents.get(i).draw(x,y);
                    y += Constants.BUTTON_HEIGHT;
                }
            }

            //userState.restoreSettingsToApplet(parent);
        //}
    }

}
