package org.rsg.interfascia_v2.components.list;

import org.rsg.interfascia_v2.Component;
import org.rsg.interfascia_v2.Font;
import java.awt.Rectangle;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import processing.core.PApplet;

public class RadioEntry extends Component {
	private static final String FONT = Font.SANS_SERIF;
	private static final int SIZE = Font.SMALL;
	protected int currentColor;
	//public boolean isSelected = false;
	protected Radio radio;
	protected PApplet papplet;
	public short id; 
	public String string;

	public RadioEntry(String string, short id, Rectangle r, Radio radio, PApplet papplet) {
		this.papplet = papplet;
		setLabel(string);
		this.string = string;
		this.id = id;
		setPosition(r.x, r.y + 1);
		setSize(r.width, r.height);
        setFontSize(SIZE);
        setFontFace(FONT);
		//initWithParent();
		papplet.registerMouseEvent(this);
		this.radio = radio;
		this.radio.add(this);
	}

	/*public void initWithParent() {
		controller.papplet.registerMouseEvent(this);
		if (lookAndFeel == null) {
			return;
		} else {
			controller.userState.saveSettingsForApplet(controller.papplet);
			lookAndFeel.defaultGraphicsState
					.restoreSettingsToApplet(controller.papplet);
			setSize((int) Math.ceil(controller.papplet.textWidth(getLabel()))
					+ getHeight() + 5, 14);
			controller.userState.restoreSettingsToApplet(controller.papplet);
			return;
		}
	}*/

	public void mouseEvent(MouseEvent e) {
		//Log.debug("[RadioEntry] " + this + " x:" + getX() + " y:" + getY() + " w:" + getWidth() + " h:" + getHeight());
		if (e.getID() == java.awt.Event.MOUSE_DOWN) {
			if (isMouseOver(e.getX(), e.getY()))
				wasClicked = true;
		} else if (e.getID() == java.awt.Event.MOUSE_UP && wasClicked && isMouseOver(e.getX(), e.getY())) {
			radio.selectButton(this);
			wasClicked = false;
		}
	}

	public void keyEvent(KeyEvent e) {
		if (e.getID() == java.awt.event.KeyEvent.KEY_TYPED
				&& e.getKeyChar() == ' ')
			radio.selectButton(this);
	}

	//public void draw(int x, int y) {
	public void draw() {
		//Log.debug(this+" draw()");
		if (isMouseOver(controller.papplet.mouseX, controller.papplet.mouseY))
			currentColor = lookAndFeel.highlightColor;
		else if (controller.getFocusStatusForComponent(this))
			currentColor = lookAndFeel.highlightColor;
		else
			currentColor = lookAndFeel.baseColor;
		int margin = 1;
		int x = getX() + margin;
		int y = getY() + margin;
		int hgt = getHeight() - margin*2;
		int wid = getWidth() - margin*2;
		
		//the button
		controller.papplet.stroke(lookAndFeel.borderColor);
		controller.papplet.fill(currentColor);
		controller.papplet.rect(x, y, hgt, hgt);
		
		//button's check
		if (radio.getSelectionStatusForButton(this)) {
			controller.papplet.stroke(lookAndFeel.borderColor);
			controller.papplet.line(x, y, x+hgt, y+hgt);
			controller.papplet.line(x+hgt, y, x, y+hgt);
		}
		
		//text label
		Font.setFont(papplet, font_face, font_size);
		controller.papplet.fill(lookAndFeel.textColor);
		controller.papplet.text(getLabel(), x + (hgt + 4), y + (hgt - 1));
		
		/*if (controller.showBounds) {
			controller.papplet.noFill();
			controller.papplet.stroke(255F, 0.0F, 0.0F);
			controller.papplet.rect(x, y, wid, hgt);
		}*/
	}

	public boolean isSelected() { return radio.getSelectionStatusForButton(this); }
	public void setSelected() { radio.selectButton(this); }
}
