package org.rsg.lib;

public class JVM {
    private static final float majorJavaVersion = getMajorJavaVersion(System.getProperty("java.specification.version"));
    static final float DEFAULT_JAVA_VERSION = 1.3f;

    private static final float getMajorJavaVersion(String javaVersion) {
        try {
            return Float.parseFloat(javaVersion.substring(0, 3));
        } catch ( NumberFormatException e ){
            // Some JVMs may not conform to the x.y.z java.version format
            return DEFAULT_JAVA_VERSION;
        }
    }

    public static boolean is14() {
        return majorJavaVersion >= 1.4f;
    }

    public static boolean is15() {
        return majorJavaVersion >= 1.5f;
    }
}
