package org.rsg.lib;

//import java.util.Iterator;
//
import java.io.IOException;
import java.io.PrintStream;
import java.util.logging.FileHandler;
import java.util.logging.Handler;
import java.util.logging.LogManager;
import java.util.logging.Logger;
import java.util.logging.SimpleFormatter;

import javax.swing.JOptionPane;

/**
 * @author RSG
 * @version 2.2
 */
public class Log {
	private static boolean DEBUG = true; 
	public final static String LINE_SEPARATOR = System.getProperty("line.separator");

	public static void main(String[] args) {

	}
		
	public static void divertToFile() {
        // initialize logging to go to rolling log file
        LogManager logManager = LogManager.getLogManager();
        logManager.reset();

        // log file max size 10K, 3 rolling files, append-on-open
        Handler fileHandler = null;
		try {
			fileHandler = new FileHandler("console.log", 100000, 1, true);
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
        fileHandler.setFormatter(new SimpleFormatter());
        Logger.getLogger("").addHandler(fileHandler);		

        // now rebind stdout/stderr to logger                                  
        Logger logger;                                                         
        LoggingOutputStream los;                                               
                                                                               
        logger = Logger.getLogger("stdout");                                   
        los = new LoggingOutputStream(logger, StdOutErrLevel.STDOUT);          
        System.setOut(new PrintStream(los, true));                             
                                                                               
        logger = Logger.getLogger("stderr");                                   
        los= new LoggingOutputStream(logger, StdOutErrLevel.STDERR);           
        System.setErr(new PrintStream(los, true));    
	}
	
	/**
	 * Opens a JOptionPane.showMessageDialog containing strings. Second string appears in parenthesis. 
	 * @param a
	 * @param b
	 */
	public static void window(String a, String b) {
		window(a + LINE_SEPARATOR + LINE_SEPARATOR + "(" + b + ")");
	}
	
	/**
	 * Opens a JOptionPane.showMessageDialog containing string
	 * @param s
	 */
	public static void window(final String s) {
//		System.err.println("[Log] window(\n"+s+"\n)");

		new Thread(new Runnable() { public void run() { //launch in thread, otherwise it blocks?  
				JOptionPane.showMessageDialog(null, s);
		} }).start(); 
	}

	public static void window(final String message, final String title, final int message_type) {
//		System.err.println("[Log] window(\n"+s+"\n)");

		new Thread(new Runnable() { public void run() { //launch in thread, otherwise it blocks?  
				JOptionPane.showMessageDialog(null, message, title, message_type);
		} }).start(); 
	}
	
	public static int macNotPromiscuous(String s) {
		Object[] options = { "Run command (prompts for password)", "Ignore" };
		return JOptionPane.showOptionDialog(	null, s, "Error -- Promiscuous Mode", 
												JOptionPane.YES_NO_CANCEL_OPTION,
												JOptionPane.WARNING_MESSAGE, null, options, options[0]);
	}

//	/**
//	 * Opens a showConfirmDialog containing string
//	 * @param a
//	 * @param b
//	 */
//	public static int confirm(String a, String b) {
//		Log.debug("[Log] confirm("+a+", "+b+")");
//		return JOptionPane.showConfirmDialog(null, a + "\n" + b, b, JOptionPane.YES_NO_OPTION);
//	}
	
	public static String confirmWithSelect(Object[] entries, String a, String b) {
		return (String)JOptionPane.showInputDialog(
		                    null,
		                    a,
		                    b,
		                    JOptionPane.PLAIN_MESSAGE,
		                    null, //TODO: make this an icon
		                    entries,
		                    (entries != null) ? entries[0] : null);
	}

	/**
	 * Turns debugging output on or off.
	 * Example: <tt>Log.setDebug(true);</tt>
	 * 
	 * @param b Options are: "true" or "false" (default)
	 */
	public static void setDebug(boolean b) {
		System.out.println("[org.rsg.carnivore.Log] setDebug: " + b);
		DEBUG = b;
	}
	
	/**
	 * If DEBUG is true, prints a string to standard out.
	 * @param s
	 */
	public static void debug(String s) {
		if(DEBUG) {
			System.out.println(s);
		}
	}

//	void printAllNodes() {
//		debug("\nNODE REPORT");
//		int counter = 0;
//		Iterator iterator = iLAN.nodes.keySet().iterator();
//		while (iterator.hasNext()) {
//			counter++;
//			Node n = (Node) iLAN.nodes.get(iterator.next());
//			debug(counter + ". " + n);
//		}
//	}
//
//	void printLAN() {
//		debug("\nLAN REPORT");
//		int counter = 0;
//		Iterator iterator = iLAN.nodes.keySet().iterator();
//		while (iterator.hasNext()) {
//			Node n = (Node) iLAN.nodes.get(iterator.next());
//			if (n.isLAN) {
//				counter++;
//				debug(counter + ". " + n);
//			}
//		}
//	}
//
//	void printWAN() {
//		debug("\nWAN REPORT");
//		int counter = 0;
//		Iterator iterator = iLAN.nodes.keySet().iterator();
//		while (iterator.hasNext()) {
//			Node n = (Node) iLAN.nodes.get(iterator.next());
//			if (n.isWAN) {
//				counter++;
//				debug(counter + ". " + n);
//			}
//		}
//	}

}
