package org.rsg.lib.chrome;

import java.util.HashSet;
import java.util.Iterator;

import processing.core.PApplet;

public class ChromeDispatcher {
	private static HashSet<ChromeListener> listeners = new HashSet<ChromeListener>();
	
	////////////////////////////////////////////////////////////////
	//add/remove from hash
	public static void add(ChromeListener object) { 
		listeners.add(object); 
//		((PApplet) object).frame.setUndecorated(true);		
		((PApplet) object).frame.setResizable(true);		
	}

	public static void remove(ChromeListener object) { 
		listeners.remove(object); 
	}

	////////////////////////////////////////////////////////////////
	//the two interface methods for ChromeListener
	public static void rescaleWindow() {
	    Iterator<ChromeListener> i = listeners.iterator();
	    while(i.hasNext()) {
	    	i.next().rescaleWindow();
	    }
	}

	public static void exit() {
	    Iterator<ChromeListener> i = listeners.iterator();
	    while(i.hasNext()) {
	    	i.next().exit();
	    }
	}
	
	////////////////////////////////////////////////////////////////
	//these can do what they need internally to Chrome system, so not included in interface
	public static void minimizeWindow() {
	    Iterator<ChromeListener> i = listeners.iterator();
	    while(i.hasNext()) {
	    	Chrome.minimize(((PApplet) i.next()));
	    }
	}

	public static void fullscreenWindow() {
	    Iterator<ChromeListener> i = listeners.iterator();
	    while(i.hasNext()) {
	    	Chrome.toggleFullscreen(((PApplet) i.next()));
	    }
	}
}
