package org.rsg.lib.chrome.button;

import java.awt.Color;
import java.awt.Rectangle;

import org.rsg.interfascia_v2.Constants;
import org.rsg.interfascia_v2.Font;
import org.rsg.lib.chrome.Chrome;
import org.rsg.lib.chrome.ChromeDispatcher;
import org.rsg.lib.color.ColorUtilities;
import org.rsg.lib.string.StringUtilities;

import processing.core.PApplet;
import processing.core.PConstants;

public class Header extends AbstractButton {
	private static final long serialVersionUID = 1L;
	public static final int SPACER_LEFT_LABEL = 10;
	
	@Override
	public void draw(PApplet papplet) {
		//not using white() because we want a slight transparency here even at full alpha
		int white = 255;
		if(Chrome.shouldAutoHide) {
			white = ColorUtilities.colorWithAlphaAsInt(Color.WHITE, Math.max(1, (Chrome.alpha() - 40)));
		} else {
			white = (new Color(96,97,100)).getRGB();			
		}
		Rectangle r = bounds();

		//top chrome box
		papplet.stroke(Chrome.black());
		papplet.fill(white);
		papplet.rect(r.x,r.y,r.width,r.height);

		//top text label
		Font.setSize(papplet, Font.NORMAL);
		papplet.fill(Chrome.black());
		papplet.noStroke();
		papplet.textAlign(PConstants.LEFT);
		//String s = Chrome.getLabel();
		String s = StringUtilities.truncate(papplet, 
											Chrome.getLabel(), 
											bounds().width - 60 - SPACER_LEFT_LABEL);//should get number programmatically from button sizes but fuck it
		papplet.text(s, SPACER_LEFT_LABEL, r.height - Constants.LEADING - 5);
	}

	@Override
	public Rectangle bounds() {
		int x = 0;
		int y = 0;
		int w = Chrome.getAPP_SIZE().width;
		int h = Chrome.HEIGHT;
		return new Rectangle(x,y,w,h);
	}

	@Override
	public boolean pick(PApplet papplet) { return false; }
	
	@Override
	public void click(PApplet papplet) {
		ChromeDispatcher.minimizeWindow();
	}

	@Override
	public String getTooltip() { return null; }
}
