package org.rsg.lib.net;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.UnknownHostException;

public class CheckForUpdate {
	public static void isUpdateAvailable(final int thisVersion, final String urlToQuery, final Method callbackIfUpdateRequired) {
//		System.out.println("[CheckForUpdate] isUpdateAvailable("+thisVersion+", "+urlToQuery+", "+callbackIfUpdateRequired+")");
        new Thread(new Runnable() { public void run() { 
        	Integer currentVersion = Integer.valueOf(getURL(urlToQuery));
    		if((int)currentVersion > thisVersion) {
				System.out.println("[CheckForUpdate] a software update is available (v"+currentVersion+").");    			
				try {
					callbackIfUpdateRequired.invoke(null, new Object[] { currentVersion } );
				} catch (IllegalArgumentException e) {
					System.err.println("[CheckForUpdate] isUpdateAvailable("+thisVersion+", "+urlToQuery+", "+callbackIfUpdateRequired+") IllegalArgumentException");
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					System.err.println("[CheckForUpdate] isUpdateAvailable("+thisVersion+", "+urlToQuery+", "+callbackIfUpdateRequired+") IllegalAccessException");
					e.printStackTrace();
				} catch (InvocationTargetException e) {
					System.err.println("[CheckForUpdate] isUpdateAvailable("+thisVersion+", "+urlToQuery+", "+callbackIfUpdateRequired+") InvocationTargetException");
					e.printStackTrace();
				}
    		} else {
				System.out.println("[CheckForUpdate] software is up to date (v"+currentVersion+").");    			
    		}
        } }).start();
	}

	public static String getURL(String s) {
		try {
			return getURL(new URL(s));
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
	
	public static String getURL(URL url) {

		String remote = "";

		try {
//			URL url = new URL(s);
			BufferedReader in = new BufferedReader(new InputStreamReader(url.openStream()));
			String inputLine;

			while ((inputLine = in.readLine()) != null)
				remote += inputLine;
			
			in.close();		
		} catch (UnknownHostException e) {
			return "";
			
		} catch (IOException e) {
			return "";
//			System.out.println("[KSUtilities] getURL("+s+"): IOException");
//			e.printStackTrace();
		}
		return remote;

	}
}
