package org.rsg.lib.net;

import java.net.InetAddress;
import java.net.NetworkInterface;
import java.util.ArrayList;
import java.util.Enumeration;

public class Localhost {
	private static ArrayList<String> _hostlist = null;
	private Localhost() {}

	public static void main(String[] args) {	
		ArrayList<String> hostlist = getHostlist();
		System.out.println("[Localhost] "+hostlist);
	}	

	public static ArrayList<String> getHostlist() {
		if(null == _hostlist) { initialize(); }
		return _hostlist;
	}
	
	private static void initialize() {
		_hostlist = new ArrayList<String>();
		ArrayList<NetworkInterface> interfaces = NetworkInterfaces.getInterfaces();
		InetAddress ia = null;
		
		for(NetworkInterface iface : interfaces) {
			for (Enumeration<InetAddress> ips = iface.getInetAddresses(); ips.hasMoreElements();) {
				ia = (InetAddress) ips.nextElement();
				_hostlist.add(ia.getCanonicalHostName());
				_hostlist.add(ia.getHostAddress());
			}
		}
	}

	public static boolean isLocal(String ip, String host) {
		if(null == _hostlist) { initialize(); }
		for(String address : _hostlist) {
			if (ip.equals(address) || host.equals(address)) 
				return true;
		}
			
		return false;
	}
}